
# stForm w
#
# Create a top-level window that displays a bunch of entries with
# tabs set up to move between them.
#
# Arguments:
#    w -	Name to use for new top-level window.

proc stxcalc_scr {{w .form }} {
   global f3
   global g0
   global f4
   global f5
   global f6
    global tabxcalc_scrList
    global helpTopics
    global F2Array
    global inxcalc_scralarm
    set  inxcalc_scralarm 0
    catch {destroy $w}
    toplevel $w
    dpos $w
    wm iconname $w "Eingabe"
    message $w.msg -font -Adobe-times-medium-r-normal--*-140* -width 4i \
    -text "Ret: Neues Feld  Alles Richtig:Verlassen"
    set oldfocus [focus]
#   catch {grab set $w}

   button $w.ok -text "Alles richtig" \
    -command "Printxcalc_scrValue ; doxcalc_scrdestroy $w; focus $oldfocus"
   wm title $w "xcalc_scr"
    foreach i { x1 x2 } {
       frame $w.$i -bd 0m
       label $w.$i.label 
       $w.$i.label config -font -Adobe-courier-medium-r-normal--*-120*
       pack $w.$i.label -side left
    }
    foreach i { x3 x4 x5 x6 x7 } {
       frame $w.$i -bd 0m
    }
    entry $w.x3.entry -relief sunken -textvariable f3 -width 12
    entry $w.x4.entry -relief sunken -textvariable g0 -width 22
    entry $w.x5.entry -relief sunken -textvariable f4 -width 12
    entry $w.x6.entry -relief sunken -textvariable f5 -width 12
    entry $w.x7.entry -relief sunken -textvariable f6 -width 12
    foreach i { x3 x5 x6 x7  x4  } {
     bind $w.$i.entry <Tab> "Savexcalc_scrValue $w; Tab \$tabxcalc_scrList"
     bind $w.$i.entry <Return> "Savexcalc_scrValue $w; Tab \$tabxcalc_scrList"
     bind $w.$i.entry <Home> "Savexcalc_scrValue $w; focus $w.x3.entry"
     bind $w.$i.entry <Control-c> "doxcalc_scrdestroy $w; focus $oldfocus"
     bind $w.$i.entry <Escape> "Savexcalc_scrValue $w; Tab \$tabxcalc_scrList"
     label $w.$i.label
     $w.$i.label config -font -Adobe-courier-medium-r-normal--*-120*
     place $w.$i.label -relx 0
    }
    doxcalc_scrbind $w
    foreach i { x4 } {
      place $w.$i.entry -relx 0.531
    }
    foreach i { x3 x5 x6 x7 } {
      place $w.$i.entry -relx 0.647
    }
      $w.x1.label config -text "Kalkulator- ESC: Ergebnis"
      $w.x2.label config -text "F5: Zwischenpuffer F6: Puffer kopieren"
      $w.x3.label config -text "1. Operand ---------->"
      $w.x4.label config -text " Operator (+,-,/,*)-->"
      $w.x5.label config -text "2. Operand ---------->"
      $w.x6.label config -text "Ergebnis   ---------->"
      $w.x7.label config -text "Weitere Berechnungen->"
      set mwidth 352
      set mlength 217
      wm geometry $w [expr $mwidth]x[expr $mlength]
      place  $w.msg -relheight 0.105 -relwidth 1.0 -rely 0.00 -relx 0.01
      place  $w.x1 -relheight 0.105 -relwidth 1.0 -rely 0.105 -relx 0.01
      place  $w.x2 -relheight 0.105 -relwidth 1.0 -rely 0.211 -relx 0.01
      place  $w.x3 -relheight 0.105 -relwidth 0.773 -rely 0.316 -relx 0.01
      place  $w.x4 -relheight 0.105 -relwidth 1.000 -rely 0.421 -relx 0.01
      place  $w.x5 -relheight 0.105 -relwidth 0.773 -rely 0.526 -relx 0.01
      place  $w.x6 -relheight 0.105 -relwidth 0.773 -rely 0.632 -relx 0.01
      place  $w.x7 -relheight 0.105 -relwidth 0.773 -rely 0.737 -relx 0.01
      place  $w.ok -relheight 0.105 -relwidth 1.0 -rely 0.842 -relx 0
      focus $w.x3.entry
      set tabxcalc_scrList "         $w.x3.entry \ 
         $w.x4.entry \ 
         $w.x5.entry \ 
         $w.x6.entry \ 
         $w.x7.entry \ 
        "
         set helpTopics($w.x3.entry) 272
         set helpTopics($w.x4.entry) 273
         set helpTopics($w.x5.entry) 274
         set helpTopics($w.x6.entry) 275
         set helpTopics($w.x7.entry) 276
    }

proc doxcalc_scrbind {w} {
    bind Label <ButtonPress>  {Myf2 [winfo containing %X %Y]}
    bind Entry <F2>  {Myf2 [winfo containing %X %Y]}
    bind Entry <ButtonPress>  {Help [winfo containing %X %Y]}
    bind Entry <F1>  {Help [winfo containing %X %Y]}
    bind all   <Enter>  {focus [winfo containing %X %Y]}
    bind all   <Leave>  "Savexcalc_scrValue $w"
}
proc doxcalc_scrunbind {w} {
    bind Label <ButtonPress> ""
    bind Entry <F2>  ""
    bind Entry <ButtonPress> 
    bind Entry <F1>   ""
    bind all   <Enter> ""
    bind all   <Leave> ""
}
proc doxcalc_scrdestroy {w} {
    global inxcalc_scralarm
    if {$inxcalc_scralarm == 0} {
       doxcalc_scrunbind $w
       destroy $w
    }
}
  proc Printxcalc_scrValue { } {
  }
proc Savexcalc_scrValue {w } {
   global f3
   global g0
   global f4
   global f5
   global f6
    global inxcalc_scralarm
    set f3 $f3
    set f4 $f4
    set f5 $f5
    set f6 $f6
}
